<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

   <v-form
      ref="form" v-model="valid"
    >

    <CommonHeader
      :title="MESSAGES.WL_GENERAL_SECTION_TITLE"
      :description="MESSAGES.WL_GENERAL_SECTION_DESCRIPTION"
    />
    <v-container>
      <v-row dense>
        <v-col cols="4" >
          <v-text-field 
            :label="MESSAGES.WL_WORKLOAD_NAME" 
            :hint="MESSAGES.WL_WORKLOAD_NAME_HELP"
            v-model="workload.workload_name"
            :rules="nameRules"
            counter="50"
            required
          ></v-text-field>
        </v-col>
        <v-col cols="4" >
          <v-text-field 
            :label="MESSAGES.WL_TOOL_NAME" 
            :hint="MESSAGES.WL_TOOL_NAME_HELP"
            v-model="workload.tool_name"
            :rules="nameRules"
            counter="50"
            required
          ></v-text-field>
        </v-col>
        <v-col cols="4" >
          <v-text-field 
            :label="MESSAGES.WL_ID" 
            :hint="MESSAGES.WL_ID_HELP"
            v-model="workload.id"
            disabled
            readonly
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12">
        
          <v-textarea 
            :label="MESSAGES.WL_WORKLOAD_DESCRIPTION" 
            :hint="MESSAGES.WL_DESCRIPTION_HELP"
            v-model="workload.description"
            :rules="descriptionRules"
            counter="200"
            auto-grow
            rows=1
            ></v-textarea>
        </v-col>
      </v-row>
      
      <v-combobox
          v-model="workload.categories"
          :hint="MESSAGES.WL_CATEGORIES_HELP"
          chips
          :label="MESSAGES.WL_CATEGORIES"
          multiple
        >
        <template v-slot:selection="{ attrs, item, select, selected }">
          <v-chip
            v-bind="attrs"
            :input-value="selected"
            close
            class="ma-1"
            label
            @click="select"
            @click:close="removeCategory(item)"
          >
            #{{ item }}
          </v-chip>
        </template>
      </v-combobox> 
      
    </v-container>

    <CommonHeader
      subtitle="Inheritance"
    />

    <v-container>
      <v-switch
        v-model="workload.abstract"
        label="Abstract: this workload cannot be executed, but only specialized."
      ></v-switch>

      <v-autocomplete
        v-model="workload.parent_workload"
        :items="workloads"
        return-object
        dense
        label="Parent Workload"
        item-value="id"
        item-text="_text"
      >
        <template slot="item" slot-scope="data">
          {{ data.item.workload_name }} ({{ data.item.tool_name }})
        </template> 
        <template slot="selection" slot-scope="data">
          {{ data.item.workload_name }} ({{ data.item.tool_name }})
        </template> 
      </v-autocomplete>

      <template v-if="workload.children_workloads && workload.children_workloads.length>0">
        Specializations of this workloads are:
        <span
          :key="child.id"
          v-for="(child, index) in workload.children_workloads"
        >
          <a @click="$emit('viewWorkload', child)">
            {{child.workload_name}}
            ({{child.tool_name}})
          </a>
          <span v-if="index+1 < workload.children_workloads.length">, </span>
        </span>
      </template>
      <template v-else>
        This workload has no specializations.
      </template>
    </v-container>
    
    <CommonHeader
      :title="MESSAGES.WL_EXECUTION_SECTION_TITLE"
      :description="MESSAGES.WL_EXECUTION_SECTION_DESCRIPTION"
    />

    <CommonHeader
      :subtitle="MESSAGES.WL_INSTALL_SECTION_TITLE"
      :description="MESSAGES.WL_INSTALL_SCRIPTS_HELP"
    />
    <KeyValues
      :entries="installScripts"
      :reservedKeys="reservedKeys"
      :keyHint="MESSAGES.WL_SCRIPT_NAME_HELP"
      :valueHint="MESSAGES.WL_SCRIPT_VALUE_HELP"
      :valueLabel="MESSAGES.WL_SCRIPT_VALUE"
      :keyLabel="MESSAGES.WL_SCRIPT_NAME"
      invalidChars=" "
      :addButtonLabel="MESSAGES.WL_ADD_SCRIPT"
      :readonly="false"
      :keyRules="installScriptNameRules"
      :multilineValue="true"
    />

    <CommonHeader
      :subtitle="MESSAGES.WL_POSTINSTALL_SECTION_TITLE"
      :description="MESSAGES.WL_POSTINSTALL_SCRIPTS_HELP"
    />
    <KeyValues
      :entries="postinstallScripts"
      :reservedKeys="reservedKeys"
      :keyHint="MESSAGES.WL_SCRIPT_NAME_HELP"
      :valueHint="MESSAGES.WL_SCRIPT_VALUE_HELP"
      :valueLabel="MESSAGES.WL_SCRIPT_VALUE"
      :keyLabel="MESSAGES.WL_SCRIPT_NAME"
      invalidChars=" "
      :addButtonLabel="MESSAGES.WL_ADD_SCRIPT"
      :readonly="false"
      :keyRules="postinstallScriptNameRules"
      :multilineValue="true"
    />

    <CommonHeader
      :subtitle="MESSAGES.WL_EXECUTE_SECTION_TITLE"
      :description="MESSAGES.WL_EXECUTE_SCRIPTS_HELP"
    />
    <KeyValues
      :entries="executeScripts"
      :reservedKeys="reservedKeys"
      :keyHint="MESSAGES.WL_SCRIPT_NAME_HELP"
      :valueHint="MESSAGES.WL_SCRIPT_VALUE_HELP"
      :valueLabel="MESSAGES.WL_SCRIPT_VALUE"
      :keyLabel="MESSAGES.WL_SCRIPT_NAME"
      invalidChars=" "
      :addButtonLabel="MESSAGES.WL_ADD_SCRIPT"
      :readonly="false"
      :keyRules="executeScriptNameRules"
      :multilineValue="true"
    />

    <CommonHeader
      :subtitle="MESSAGES.WL_CLEANUP_SECTION_TITLE"
      :description = "MESSAGES.WL_CLEANUP_SCRIPTS_HELP"
    />
    <KeyValues
      :entries="cleanupScripts"
      :reservedKeys="reservedKeys"
      :keyHint="MESSAGES.WL_SCRIPT_NAME_HELP"
      :valueHint="MESSAGES.WL_SCRIPT_VALUE_HELP"
      :valueLabel="MESSAGES.WL_SCRIPT_VALUE"
      :keyLabel="MESSAGES.WL_SCRIPT_NAME"
      invalidChars=" "
      :addButtonLabel="MESSAGES.WL_ADD_SCRIPT"
      :readonly="false"
      :keyRules="cleanupScriptNameRules"
      :multilineValue="true"
    />

    <CommonHeader
      :subtitle="MESSAGES.WL_USER_SCRIPTS_SECTION_TITLE"
      :description = "MESSAGES.WL_USER_SCRIPTS_HELP"
    />
    <KeyValues
      :entries="userScripts"
      :reservedKeys="reservedKeys"
      :keyHint="MESSAGES.WL_SCRIPT_NAME_HELP"
      :valueHint="MESSAGES.WL_SCRIPT_VALUE_HELP"
      :valueLabel="MESSAGES.WL_SCRIPT_VALUE"
      :keyLabel="MESSAGES.WL_SCRIPT_NAME"
      invalidChars=" "
      :addButtonLabel="MESSAGES.WL_ADD_SCRIPT"
      :readonly="false"
      :keyRules="userScriptNameRules"
      :multilineValue="true"
    />

    <CommonHeader
      :subtitle="MESSAGES.WL_PARAMETERS_SECTION_TITLE"
      :description = "MESSAGES.WL_WORKLOAD_PARAMETERS_HELP"
    />
    <KeyValues
      :entries="workloadParameters"
      :keyHint="MESSAGES.WL_PARAMETER_NAME_HELP"
      :valueHint="MESSAGES.WL_PARAMETER_VALUE_HELP"
      invalidChars=" "
      :addButtonLabel="MESSAGES.WL_ADD_PARAMETER"
      :readonly="false"
      :multilineValue="true"
    />

    <CommonHeader
      :title="MESSAGES.WL_SHARING_SECTION_TITLE"
      :description="MESSAGES.WL_SHARING_SECTION_DESCRIPTION"
    />

    <v-container>
      <v-radio-group v-model="sharing">
        <v-radio value="private"
          :label="MESSAGES.WL_PRIVATE"
        >
        </v-radio>
        <v-radio value="public"
          :label="MESSAGES.WL_PUBLIC"
        >
        </v-radio>
      </v-radio-group>
    </v-container>

    <template v-if="false">

    <CommonHeader
      :title="MESSAGES.WL_RESULTS_SECTION_TITLE"
    />
    <todo>links to grafana or embedded reports... or nothing</todo>

    </template>

    <v-divider/>
    
    <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn small @click="exit()">{{MESSAGES.BACK}}</v-btn>
        <v-btn
          v-if="workload.id==null" 
          color="primary"
          :disabled="!valid"
          v-on:click="save(true)"
        >{{MESSAGES.CREATE_AND_EXIT}}</v-btn>
        <v-btn
          v-else
          color="primary"
          :disabled="!valid"
          v-on:click="save(true)"
        >{{MESSAGES.SAVE_AND_EXIT}}</v-btn>
    </v-card-actions>


    </v-form>

  </v-container>

</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';
import KeyValues from '../common/KeyValues.vue';
import todo from '../common/ToDo.vue';

import { MESSAGES } from "../common/messages";

import { getWorkloadSharingLevel } from '../common/benchsuite.js';


export default {

 name: 'WorkloadEditor',

 components: {
    CommonHeader,
    KeyValues,
    todo    
  },
  
  props: {
    workloadId: {
      type: String,
      default: ''
    },
    templateWorkloadId: {
      type: String,
      default: ''
    },
    workloadTemplate: {
      type: Object,
      default: function() {return {}}
    }
  },

  data: () => ({
  
    MESSAGES : MESSAGES,
  
    workload : {grants:{}, categories:[], workload_parameters:{}},
    
    installScripts: [],
    postinstallScripts: [],
    executeScripts: [],
    cleanupScripts: [],
    userScripts: [],
    workloadParameters : [],
    
    workloads: [],

    sharing : "private",

    reservedKeys : ["children_workloads", "abstract", "parent_workload", "parent_workload_id", "grants", "workload_name", "tool_name", "description", "id", "class", "parser", "categories", "workload_parameters"],

    nameRules: [
        v => !!v || 'A name is required',
        v => (v && v.length <= 50) || 'Name must be less than 50 characters',
      ],

    descriptionRules: [
        v => !v || (v && v.length <= 200) || 'Description must be less than 200 characters',
      ],

    installScriptNameRules: [
        v => !v || (v.startsWith("install".substring(0, v.length))) || "Install scripts must start with 'install'",
        v => !v || (v.startsWith("install_".substring(0, v.length))) || "Install scripts must start with 'install_'",
      ],

    postinstallScriptNameRules: [
        v => !v || (v.startsWith("postinstall".substring(0, v.length))) || "Post-Install scripts must start with 'postinstall'",
        v => !v || (v.startsWith("postinstall_".substring(0, v.length))) || "Post-Install scripts must start with 'postinstall_'",
      ],
      
    executeScriptNameRules: [
        v => !v || (v.startsWith("execute".substring(0, v.length))) || "Execute scripts must start with 'execute'",
        v => !v || (v.startsWith("execute_".substring(0, v.length))) || "Execute scripts must start with 'execute_'",
      ],
      
    cleanupScriptNameRules: [
        v => !v || (v.startsWith("cleanup".substring(0, v.length))) || "Cleanup scripts must start with 'cleanup'",
        v => !v || (v.startsWith("cleanup_".substring(0, v.length))) || "Cleanup scripts must start with 'cleanup_'",
      ],
      
    userScriptNameRules: [
        v => !v || (!v.startsWith("install")) || "User scripts cannot start with 'install'",
        v => !v || (!v.startsWith("execute")) || "User scripts cannot start with 'execute'",
        v => !v || (!v.startsWith("cleanup")) || "User scripts cannot start with 'cleanup'"
      ],

    
    valid : false

    
  }),

  mounted () {
    if(this.workloadTemplate && this.workloadTemplate.workload_name) {
      this.workload = this.workloadTemplate;
      this.buildWorkloadParameters();
      this.buildScripts();
      this.sharing = getWorkloadSharingLevel(this.workload);
      // load the parent, if any
      if(this.workloadTemplate.parent_workload_id) {
        console.log("loading parent");
        this.$store.commit('fbkon')
        this.$http
              .get(this.$REST_BASE_URL + '/workloads/'+this.workloadTemplate.parent_workload_id+'?embed_parent=false&resolve=false&embed_children=false')
          .then(response => {
            this.workload.parent_workload = response.data;
          }
        )
        .finally(() => {this.$store.commit('fbkoff')});
      }
    } else if(this.workloadId) {
      this.$store.commit('fbkon')
      this.$http
            .get(this.$REST_BASE_URL + '/workloads/'+this.workloadId+'?embed_parent=true&resolve=true&embed_children=true')
        .then(response => {
          this.workload = response.data;
          this.buildWorkloadParameters();
          this.buildScripts();
          this.sharing = getWorkloadSharingLevel(this.workload);
        }
      )
      .finally(() => {this.$store.commit('fbkoff')});

    } else if(this.templateWorkloadId) {
      this.$store.commit('fbkon')
      this.$http
            .get(this.$REST_BASE_URL + '/workloads/'+this.templateWorkloadId+'?embed_parent=true&resolve=true&embed_children=true')
        .then(response => {
          this.workload = response.data;
          this.workload.id=null;
          this.workload.name='Copy of '+this.workload.name; 
          this.workload.grants={owner:'me'}
          this.buildWorkloadParameters();
          this.buildScripts();
          this.sharing = getWorkloadSharingLevel(this.workload);
        }
      )
      .finally(() => {this.$store.commit('fbkoff')});

    } else {
      this.workload = Object.assign({}, this.workloadTemplate, { workload_name: "New Workload2" })
    }
    
    this.loadWorkloads();
  },

  methods:{
  
   getAvailableWorkloads: function() {
    return [];
   },
  
   removeCategory: function(category) {
     var index = this.workload.categories.indexOf(category);
     if (index > -1) {
       this.workload.categories.splice(index, 1);
     }
   },

   buildWorkloadParameters: function() {
    this.workloadParameters.splice(0, this.workloadParameters.length)
    for(var k in this.workload.workload_parameters) {
      if(this.workload.workload_parameters[k]) {
        this.workloadParameters.push({"key":k, "value":this.workload.workload_parameters[k]});
      }
    }
   },

   buildScripts: function() {
    this.installScripts.splice(0, this.installScripts.length)
    this.postinstallScripts.splice(0, this.postinstallScripts.length)
    this.executeScripts.splice(0, this.executeScripts.length)
    this.cleanupScripts.splice(0, this.cleanupScripts.length)
    this.userScripts.splice(0, this.userScripts.length)
    
    var is = this.getScripts("install");
    for(var i in is) {
      this.installScripts.push(is[i]);
    }

    var pis = this.getScripts("postinstall");
    for(i in pis) {
      this.postinstallScripts.push(pis[i]);
    }

    var es = this.getScripts("execute");
    for(i in es) {
      this.executeScripts.push(es[i]);
    }

    var cs = this.getScripts("cleanup");
    for(i in cs) {
      this.cleanupScripts.push(cs[i]);
    }
    
    var us = this.getOtherScripts();
    for(i in us) {
      this.userScripts.push(us[i]);
    }
    
   },

    getScripts: function(command) {
      var out = [];
      for(var k in this.workload) {
        var level = this.getScriptLevel(k, command);
        if(level>0) {
          out.push({key:k, value:this.workload[k], weight:level, highlight:level>1, icon:"mdi-code-greater-than"});
        }
      }
      
      // now sort them by weight, then by name
      out.sort(function(a, b){
        var res = b.weight-a.weight
        if(res!=0)
          return res;
        return b.key < a.key;
      })
      
      return out;
    },

    getOtherScripts: function() {
      var out = [];
      for(var k in this.workload) {
        if(!k.startsWith("install") && !k.startsWith("postinstall") && !k.startsWith("exec") && !k.startsWith("cleanup") && !this.reservedKeys.includes(k)) {
          out.push({key:k, value:this.workload[k]});
        }
      }
      return out;
    },

    getScriptLevel: function(name, command) {
      var commands = command!=null ? "("+command+")" : "(install|execute|cleanup)";
      var platforms = "(debian|centos|ubuntu)";
      var re = new RegExp("^"+commands+"_"+platforms+"_[0-9\\.]+$", "g");
      if(name.match(re))
        return 4;
      re = new RegExp("^"+commands+"_"+platforms+"$", "g");
      if(name.match(re))
        return 3;
      re = new RegExp("^"+commands+"$", "g");
      if(name.match(re))
        return 2;
      re = new RegExp("^"+commands, "g");
      if(name.match(re))
        return 1;
      return 0;
    },

   loadWorkloads: function() {
     this.$http.get(this.$REST_BASE_URL + "/workloads/")
    .then(response => {
        this.workloads = response.data;
        
        // build a property to support autocomplete
        var self = null;
        for(var i in this.workloads) {
          var wl = this.workloads[i];
          if(wl.id==this.workload.id)
            self = wl;
          wl._text = wl.workload_name + " " + wl.tool_name + " " + wl.description;
          for(var c in wl.categories) {
            wl._text += " " + wl.categories[c];
          }
        }
        
        this.workloads = this.workloads.filter(item => item !== self)

        
        this.workloads.sort(function(a, b){
          if(a.workload_name < b.workload_name) {
            return -1;
          } else if(a.workload_name > b.workload_name) {
            return 1;
          } else if(a.tools_name < b.tools_name) {
            return -1;
          } else if(a.tools_name > b.tools_name) {
            return 1;
          } else {
            return a.id > b.id ? 1 : -1;
          }
        })
      }
    )
    .catch(e => {console.log(e)})
    .finally(() => {} );
   },
  
   packForSave: function() {
   
     var uploadData = {};

     // basic fields
     var keys = ["workload_name", "tool_name", "id", "description", "categories", "abstract"];
     for(var i in keys) {
       var key = keys[i];
       if(this.workload[key]) {
         uploadData[key] = this.workload[key];
       }
     }
     
     // parent workload
     if(this.workload.parent_workload) {
       uploadData["parent_workload_id"] = this.workload.parent_workload.id;
     }
     
     // scripts
     for(i in this.installScripts) {
       var script = this.installScripts[i];
       uploadData[script.key] = script.value;
     }
     for(i in this.postinstallScripts) {
       script = this.postinstallScripts[i];
       uploadData[script.key] = script.value;
     }
     for(i in this.executeScripts) {
       script = this.executeScripts[i];
       uploadData[script.key] = script.value;
     }
     for(i in this.cleanupScripts) {
       script = this.cleanupScripts[i];
       uploadData[script.key] = script.value;
     }
     for(i in this.userScripts) {
       script = this.userScripts[i];
       uploadData[script.key] = script.value;
     }
     
     // parameters 
     uploadData.workload_parameters = {};
     for(i in this.workloadParameters) {
       var param = this.workloadParameters[i];
       uploadData.workload_parameters[param.key] = param.value;
     }

     // set grants
     if(this.sharing=="private") {
       uploadData.grants = {};
     } else if(this.sharing=="public") {
       uploadData.grants = {executor:"org:public"};
     } else {
       uploadData.grants = {};
     }

     return uploadData;
     
   },

   save: function(exit){
   
    var toUpload = this.packForSave();

    // set feedback ON    
    this.$store.commit('fbkon')

    // create or update (depending on id)
    if(toUpload.id==null) {
      this.$http.post(this.$REST_BASE_URL + "/workloads", toUpload)
      .then((response) => {
          this.workload = response.data;
          this.workload.id = response.data.id;
          if(exit)
            this.exit(this.workload.id);
        }
      )
      .catch(e => {console.log(e)})
      .finally(() => {this.$store.commit('fbkoff')});
    } else {
      this.$http.put(this.$REST_BASE_URL + "/workloads/"+toUpload.id, toUpload)
        .then(() => {
          this.workload = toUpload;
          if(exit)
            this.exit(this.workload.id);
        }
      )
      .catch(e => {console.log(e)})
      .finally(() => {this.$store.commit('fbkoff')});
    }
    
   },

   exit: function(id) {
      id = id || this.workloadId || this.templateWorkloadId;
      this.$emit("editingWorkloadComplete", {id:id})
   },
  
  }

};

</script>
